;============================================================================
;PROJEKT:  CDpanel
;DATUM:    05/2002
;AUTOR:    Papouch s.r.o. - www.papouch.com
;===========================================================================
;Popis:    Ovladaci panel k CD-ROM
;===========================================================================
;Licence:  Pouziti pouze pro nekomercni ucely!
;          V pripade zajmu o komercni pouziti kontaktujte Papouch s.r.o.
;===========================================================================

; ------------- konstanty ----------------------------------------------------
		.equ	MaxNextTrackTimeout,15
; ------------- vstupy a vystupy ---------------------------------------------
		.equ	Ena,p3.7
		.equ	RW,p3.6
		.equ	RS,p3.5
		.equ	KeybCS,p3.4
		.equ	RemotePin,p3.3
		.equ	INTRQ,p3.2
		.equ	LCDData,p0
		.equ	IDEResetPin,p2.0
		.equ	CS1,p2.1
		.equ	CS0,p2.2
		.equ	A2,p2.3
		.equ	A1,p2.4
		.equ	A0,p2.5
		.equ	RD,p2.6
		.equ	WR,p2.7
		.equ	CDLData,p0
		.equ	CDHData,p1
; ------------- 8-bitove registry --------------------------------------------
		.equ	AtapiError,h'30
		.equ	CDSize,h'31		; 4 B delka CD MSF
		.equ	Pozice1,h'35		; 4 B bud sektor nebo MSF
		.equ	Pozice2,h'39		; 4 B bud sektor nebo MSF
		.equ	TrackNr,h'3d		; cislo zvoleneho tracku
		.equ	NrOfTracks,h'3e		; pocet tracku na CD
		.equ	Timeout,h'3f		; 2 B -> max. 65536x smycka
		.equ	SenseKey,h'41
		.equ	ASC,h'42
		.equ	ASCQ,h'43
		.equ	TrackP,h'44
		.equ	IndexP,h'45
		.equ	Mode,h'46
		.equ	RepeatMode,h'47
		.equ	OldKey,h'48
		.equ	TimeMode,h'49
		.equ	TrackSize,h'4a		; 4 B delka tracku MSF
		.equ	CDSizeHSG,h'4e		; 4 B delka CD v sektorech
		.equ	NextTrack,h'52		; cislo tracku, ktery bude
						; nasledovat, protoze bylo
						; stisknuto tlacitko prev/next
		.equ	NextTrackTimeout,h'53
		.equ	PacketCommand,h'60	; 12 B
		.equ	CDROMDataWords,h'60	; 32 B
		.equ	EndCDROMDataWords,h'80
; ------------- 1-bitove registry --------------------------------------------
		.equ	DRQ_INTRQMode,h'7f
		.equ	Random,h'7e
		.equ	DoorOpened,h'7d
		.equ	NoDisc,h'7c
; ------------- P R O G R A M ------------------------------------------------
		.org	0
		sjmp	Start
Start:
		mov	tmod,#1
		clr	a
		mov	tl0,a
		mov	th0,a
		setb	tr0
		acall	InitDisp
		mov	r4,#100
zpx:
		acall	zp2
		djnz	r4,zpx
		acall	IDEReset
		mov	a,#16
		acall	SetDPos
		mov	dptr,#UvLogo2
		acall	Print
		mov	r4,#100
zpx2:
		acall	zp2
		djnz	r4,zpx2
		acall	IDEInitDevice
		acall	InitClose
		mov	RepeatMode,#0
		mov	TimeMode,#0
		mov	OldKey,#255
		clr	Random

HlSm:
		mov	a,Mode
		jnz	SkipDelay
		acall	zp2
		acall	zp2
SkipDelay:
		acall	ZobrMode
		acall	ProvedKey
		acall	ProvedPrevNext
		acall	TestNewCD
		sjmp	HlSm
; ------------- pokud neni CD, otestuje, zda se uz nenacetlo -----------------
TestNewCD:
		jnb	NoDisc,EndTestNewCD
		clr	a
		mov	NrOfTracks,a
		lcall	TrackSector
		lcall	RequestSense
		mov	a,SenseKey
		jnz	NeniNewCD
		clr	NoDisc
NeniNewCD:
		ajmp	Stop
EndTestNewCD:
		ret
; ------------- provedeni stisknute Klavesy ----------------------------------
ProvedKey:
		mov	CDHData,#255
		clr	KeybCS
		mov	a,CDHData
		setb	KeybCS
		cjne	a,OldKey,NewKey
		sjmp	EndProvedKey
NewKey:
		mov	OldKey,a
		cjne	a,#b'11111110,NeniEject
		ajmp	Eject
NeniEject:
		jb	DoorOpened,EndProvedKey
		cjne	a,#b'11111011,NeniStop
		ajmp	Stop
NeniStop:
		jb	NoDisc,EndProvedKey
		cjne	a,#b'11101111,NeniPlay
		ajmp	Play
NeniPlay:
		cjne	a,#b'11110111,NeniPrevious
		sjmp	Previous
NeniPrevious:
		cjne	a,#b'11011111,NeniNext
		sjmp	Next
NeniNext:
		cjne	a,#b'11111100,NeniRepeat
		sjmp	RepeatProc
NeniRepeat:
		cjne	a,#b'11111001,NeniRandom
		sjmp	RandomProc
NeniRandom:
		cjne	a,#b'11101101,NeniTimeMode
		sjmp	TimeModeProc
NeniTimeMode:
;		cjne	a,#b'11110101,NeniBackward
;		sjmp	Backward
;NeniBackward:
;		cjne	a,#b'11011101,NeniForward
;		sjmp	Forward
;NeniForward:
EndProvedKey:
		ret
; ------------- FORWARD ------------------------------------------------------
Forward:
		mov	Mode,#3
		ret
; ------------- FORWARD ------------------------------------------------------
Backward:
		mov	Mode,#4
		ret
; ------------- RANDOM -------------------------------------------------------
RandomProc:
		cpl	Random
		ret
; ------------- REPEAT -------------------------------------------------------
RepeatProc:
		mov	a,RepeatMode
		inc	a
		cjne	a,#3,OkRepeat
		clr	a
OkRepeat:
		mov	RepeatMode,a
		ret
; ------------- TIME MODE ----------------------------------------------------
TimeModeProc:
		mov	a,TimeMode
		inc	a
		anl	a,#3
		mov	TimeMode,a
		ret
; ------------- NEXT ---------------------------------------------------------
Next:
		mov	a,NextTrack
		jnz	OkNewNext
		mov	a,TrackNr
OkNewNext:
		cjne	a,NrOfTracks,OkNext
		sjmp	EndNext
OkNext:
		inc	a
		mov	NextTrack,a
		mov	NextTrackTimeout,#MaxNextTrackTimeout
EndNext:
		ret
; ------------- PREVIOUS -----------------------------------------------------
Previous:
		mov	a,NextTrack
		jnz	OkNewPrevious
		mov	a,TrackNr
OkNewPrevious:
		jnz	OkPrevious
		mov	a,NrOfTracks
		inc	a
OkPrevious:
		dec	a
		jz	EndPrevious
		mov	NextTrack,a
		mov	NextTrackTimeout,#MaxNextTrackTimeout
EndPrevious:
		ret
; ------------- vykonani previous/next po vyprseni timeoutu ------------------
ProvedPrevNext:
		mov	a,NextTrack
		jz	EndProvedPrevNext
		djnz	NextTrackTimeout,EndProvedPrevNext
		mov	TrackNr,a
		mov	NextTrack,#0
		acall	StopAudio
		lcall	GetTrackSize
		mov	a,Mode
		jz	EndPrevious
		lcall	PlayFromTrack
		mov	a,Mode
		cjne	a,#2,EndPrevious
		acall	PauseAudio
EndProvedPrevNext:
		ret
; ------------- EJECT --------------------------------------------------------
Eject:
		jb	DoorOpened,Close
		mov	a,Mode
		jz	PokrEject
		acall	Stop
PokrEject:
		acall	SmazDisplej
		mov	dptr,#OpeningText
		acall	Print
		acall	CheckCDROMReady
		acall	UnlockDoor
		acall	CheckCDROMReady
		acall	OpenDoor
		clr	a
		mov	TrackNr,a
		mov	NextTrack,a
		mov	NrOfTracks,a
		mov	CDSize,a
		mov	CDSize+1,a
		mov	CDSize+2,a
		mov	CDSize+3,a
		setb	DoorOpened
		ret
Close:
		acall	SmazDisplej
		mov	dptr,#ClosingText
		acall	Print
InitClose:
		clr	NoDisc
		clr	DoorOpened
		acall	CheckCDROMReady
		acall	CloseDoor
		acall	CheckCDROMReady
		mov	a,SenseKey
		jz	ClosedOk
		setb	NoDisc
ClosedOk:
		acall	LockDoor
		sjmp	Stop
; ------------- STOP ---------------------------------------------------------
Stop:
		jb	NoDisc,NoDiscStop
		acall	CheckCDROMReady
		acall	StopAudio
		acall	CheckCDROMReady
		mov	a,SenseKey
		jnz	NoDiscStop
		mov	a,#1
		lcall	TrackSector
		clr	a
		mov	TrackNr,a
		mov	NextTrack,a
		mov	Mode,a
		acall	CheckCDROMReady
		mov	a,SenseKey
		jnz	NoDiscStop
		acall	GetCDSize
		ret
NoDiscStop:
		clr	a
		mov	TrackNr,a
		mov	NextTrack,a
		mov	NrOfTracks,a
		mov	Mode,a
		mov	CDSize,a
		mov	CDSize+1,a
		mov	CDSize+2,a
		mov	CDSize+3,a
		ret
; ------------- PLAY ---------------------------------------------------------
Play:
		acall	CheckCDROMReady
		mov	a,Mode
		cjne	a,#1,PokrPlay
		sjmp	Pause
PokrPlay:
		cjne	a,#2,PokrPlay2
		sjmp	Resume
PokrPlay2:
		mov	TrackP,#0
		mov	Mode,#1
		mov	a,TrackNr
		jnz	OkPlay
		ajmp	CheckNewPosition
		mov	a,TrackNr
OkPlay:
		lcall	PlayFromTrack
		acall	CheckCDROMReady
EndPlay:
		ret
; ------------- PAUSE --------------------------------------------------------
Pause:
		acall	PauseAudio
		mov	Mode,#2
		ret
; ------------- RESUME -------------------------------------------------------
Resume:
		acall	ResumeAudio
		mov	Mode,#1
		ret
; ------------- zjisti, co se ma prehravat po skonceni tracku/CD -------------
RandomPosition:
		mov	TrackP,#0
		mov	r7,tl0
		mov	a,r7
GetRndPos:
		clr	c
		subb	a,NrOfTracks
		jc	OkRndPos
		mov	r7,a
		sjmp	GetRndPos
OkRndPos:
		mov	TrackNr,r7
		sjmp	OkNewPosition
CNPRep1:
		mov	TrackP,#0
		mov	a,TrackNr
		dec	a
		mov	TrackNr,a
		sjmp	OkNewPosition
CNPInitPlay:
		lcall	PlayFromTrack
		ret
CheckNewPosition:

;		acall	smazdisplej
;		mov	a,TrackP
;		acall	zobrhex
;		mov	a,CDSize+2
;		acall	zobrhex
;		mov	a,CDSize+1
;		acall	zobrhex
;		mov	a,CDSize
;		acall	zobrhex
;loop:
;		sjmp	loop

		jb	Random,RandomPosition
		mov	a,RepeatMode
		jnz	TestRepeat
		mov	a,TrackNr
		cjne	a,NrOfTracks,OkNewPosition
		ajmp	Stop
TestRepeat:
		dec	a
		jz	CNPRep1
		mov	a,TrackNr
		cjne	a,NrOfTracks,OkNewPosition
		mov	TrackP,#0
		mov	TrackNr,#0
OkNewPosition:
		mov	a,TrackNr
		inc	a
		mov	TrackNr,a
		lcall	CheckCDROMReady
		lcall	GetTrackSize
		mov	a,TrackNr
		cjne	a,TrackP,CNPInitPlay
		ret
; ------------- zobrazeni na displej podle Mode ------------------------------
ZobrMode:
		mov	a,Mode
;		cjne	a,#1,SkipGetPos
		jz	SkipGetPos
		lcall	PlayingPosition
		jz	OkPlayPos
		clr	c
		subb	a,#h'11
		jz	OkPlayPos
		dec	a
		jz	OkPlayPos
		mov	a,Mode
		dec	a
		dec	a
		jz	OkPlayPos
		dec	a
		jz	OkPlayPos
		dec	a
		jz	OkPlayPos
		sjmp	CheckNewPosition
OkPlayPos:
		mov	a,Pozice1
		orl	a,Pozice1+1
		orl	a,Pozice1+2
		orl	a,Pozice1+3
		jz	SkipGetPos
		mov	a,Mode
		cjne	a,#1,SkipGetPos
		mov	a,TrackP
		cjne	a,TrackNr,CheckNewPosition
SkipGetPos:
		clr	a
		acall	SetDPos
		mov	a,NextTrack
		jnz	isNextTrack
		mov	a,TrackNr
isNextTrack:
		acall	zobrdec
		mov	a,#47
		acall	zobrdisp
		mov	a,NrOfTracks
		acall	zobrdec
		mov	a,#32
		acall	zobrdisp
		acall	zobrdisp
		acall	ZobrModeSymbol
		mov	a,#32
		acall	zobrdisp
		acall	ZobrTime
		mov	a,#16
		acall	SetDPos
		mov	dptr,#NoRepeatText
		mov	a,RepeatMode
		jz	ZobrRepeat
		jb	Random,ZobrRepeat
		mov	dptr,#Repeat1Text
		dec	a
		jz	ZobrRepeat
		mov	dptr,#RepeatAllText
ZobrRepeat:
		acall	Print
		mov	dptr,#NoRandomText
		jnb	Random,ZobrRandom
		mov	dptr,#RandomText
ZobrRandom:
		acall	Print
		ret
; ------------- zobrazeni symbolu podle Mode ---------------------------------
ZobrModeSymbol:
		mov	a,Mode
		jz	ZobrStopSymbol
		dec	a
		jz	ZobrPlaySymbol
		dec	a
		jz	ZobrPauseSymbol
		ret
ZobrStopSymbol:
		clr	a
		acall	zobrdisp
		acall	zobrdisp
		ret
ZobrPlaySymbol:
		mov	a,#1
		acall	zobrdisp
		mov	a,#32
		acall	zobrdisp
		ret
ZobrPauseSymbol:
		clr	a
		acall	zobrdisp
		mov	a,#1
		acall	zobrdisp
		ret
; ------------- zobrazeni casu -----------------------------------------------
ZobrTime:
		mov	a,Mode
		jz	ZobrStopTime
		mov	a,TimeMode
		rrc	a
		mov	a,#32
		jnc	ZobrPlus
		mov	a,#45
ZobrPlus:
		acall	zobrdisp
		mov	a,TimeMode
		jz	ZobrTime0
		dec	a
		jz	ZobrTime1
		dec	a
		jz	ZobrTime2
		dec	a
		jz	ZobrTime3
		ret
ZobrTime0:
		mov	a,Pozice2+2
		acall	zobrdec
		mov	a,#58
		acall	zobrdisp
		mov	a,Pozice2+1
		acall	zobrdec
		ret
ZobrTime1:
		mov	a,TrackSize+1
		clr	c
		subb	a,Pozice2+1
		jnc	OkZT1Sec
		push	psw
		add	a,#60
		pop	psw
OkZT1Sec:
		push	acc
		mov	a,TrackSize+2
		subb	a,Pozice2+2
		acall	zobrdec
		mov	a,#58
		acall	zobrdisp
		pop	acc
		acall	zobrdec
		ret
ZobrTime2:
		mov	a,Pozice1+2
		acall	zobrdec
		mov	a,#58
		acall	zobrdisp
		mov	a,Pozice1+1
		acall	zobrdec
		ret
ZobrTime3:
		mov	a,CDSize+1
		clr	c
		subb	a,Pozice1+1
		jnc	OkZT3Sec
		push	psw
		add	a,#60
		pop	psw
OkZT3Sec:
		push	acc
		mov	a,CDSize+2
		subb	a,Pozice1+2
		acall	zobrdec
		mov	a,#58
		acall	zobrdisp
		pop	acc
		acall	zobrdec
		ret
ZobrStopTime:
		mov	a,#32
		acall	zobrdisp
		mov	a,TrackNr
		jnz	ZobrTrackTime
		mov	a,CDSize+2
		acall	zobrdec
		mov	a,#58
		acall	zobrdisp
		mov	a,CDSize+1
		acall	zobrdec
		ret
ZobrTrackTime:
		mov	a,TrackSize+2
		acall	zobrdec
		mov	a,#58
		acall	zobrdisp
		mov	a,TrackSize+1
		acall	zobrdec
		ret
; ------------- inicializace displeje ----------------------------------------
InitDisp:
		acall	zp1		; cekani nez je displej ready
		clr	Ena
		clr	RS
		clr	RW
		mov	LCDData,#b'00110000	;inicialize displeje
		acall	Zapis
		acall	zp2
		acall	Zapis
		acall	zp3
		acall	Zapis
		mov	a,#b'00111000	; osmibitovy instrukcni soubor
		acall	CtrlDisp
		mov	a,#h'0f		; zapnuti displeje
		acall	CtrlDisp
		acall	SmazDisplej
		mov	a,#b'00000110	; nastaveni vstupniho rezimu
		acall	CtrlDisp
		mov	a,#b'00001100	; nastaveni rezimu displeje
		acall	CtrlDisp
		mov	a,#b'01000000	; uzivatelske znaky
		acall	CtrlDisp
		mov	dptr,#UZnaky	; UZnaky
		lcall	Print
		clr	a
		acall	SetDPos
		mov	dptr,#UvLogo
		acall	Print
		ret
; ------------- ekn na displej --------------------------------------------
WDisp:		clr	RS
		setb	RW
		push	acc
wdisp2:		mov	LCDData,#255
		setb	Ena
		mov	a,LCDData
		clr	Ena
		rlc	a
		jc	wdisp2
		pop	acc
		ret
; ------------- vysln kontrolnho znaku na displej -------------------------
CtrlDisp:
		acall	WDisp
		clr	RW
		clr	RS
		mov	LCDData,a
		setb	Ena
		nop
		nop
		nop
		clr	Ena
		ret
; ------------- vysln datovho znaku na displej ----------------------------
ZobrDisp:
		acall	WDisp
		clr	RW
		setb	RS
		mov	LCDData,a
		setb	Ena
		nop
		nop
		nop
		clr	Ena
		ret
; ------------- vygenerovn zpisovho pulzu pro displej --------------------
Zapis:
		setb	Ena
		nop
		nop
		nop
		clr	Ena
		ret
; ------------- nastaven pozice kurzoru na displeji -------------------------
SetDPos:
		clr	c
		swap	a
		rrc	a
		push	psw
		clr	c
		rlc	a
		swap	a
		rlc	a
		rlc	a
		pop	psw
		rrc	a
		setb	c
		rrc	a
		acall	CtrlDisp
		mov	a,#b'00001100	; nastaveni rezimu displeje
		acall	CtrlDisp
		ret
; ------------- zobrazen etzce na displej ---------------------------------
Print:
		push	6
		clr	a
		movc	a,@a+dptr
		mov	r6,a
		inc	dptr
PrintSm:
		clr	a
		movc	a,@a+dptr
		acall	ZobrDisp
		inc	dptr
		djnz	r6,PrintSm
		pop	6
		ret
; ------------- smazn displeje ---------------------------------------------
SmazDisplej:
		mov	a,#b'00000001	; smazani displeje
		acall	CtrlDisp
		clr	a
		acall	SetDPos
		ret
; ------------- zpozdovaci rutiny --------------------------------------------
zp1:		mov	r7,#200
zpsm1:		mov	r6,#100
zpsm12:		djnz	r6,zpsm12
		djnz	r7,zpsm1
		ret
zp2:		mov	r7,#200
zpsm2:		mov	r6,#150
zpsm22:		djnz	r6,zpsm22
		djnz	r7,zpsm2
		ret
zp3:		mov	r7,#200
zpsm3:		mov	r6,#50
zpsm32:		djnz	r6,zpsm32
		djnz	r7,zpsm3
		ret
; ------------- HEX zobrazeni na displej -------------------------------------
zobrhex:
		push	acc
		push	acc
		mov	dptr,#HexTab
		swap	a
		anl	a,#15
		movc	a,@a+dptr
		acall	zobrdisp
		pop	acc
		anl	a,#15
		movc	a,@a+dptr
		acall	zobrdisp
		pop	acc
		ret
; ------------- DEC zobrazeni na displej -------------------------------------
zobrdec:
		push	acc
		push	b
		mov	b,#10
		div	ab
		add	a,#48
		acall	zobrdisp
		mov	a,b
		add	a,#48
		acall	zobrdisp
		pop	b
		pop	acc
		ret
; ------------- tabulka pro uivatelsk znaky --------------------------------
UZnaky:		.db	16
		.db	b'00000
		.db	b'01110
		.db	b'01110
		.db	b'01110
		.db	b'01110
		.db	b'01110
		.db	b'00000
		.db	0
		.db	b'00000
		.db	b'11000
		.db	b'11100
		.db	b'11110
		.db	b'11100
		.db	b'11000
		.db	b'00000
		.db	0
HexTab:
		.db	"0123456789ABCDEF"
; ------------- zapis bajtu do IDE zarizeni, b=adresa, a=data ----------------
IDEWriteByte:
		mov	CDLData,a
		mov	CDHData,r2
		push	acc
		mov	a,b
		rrc	a
		mov	A0,c
		rrc	a
		mov	A1,c
		rrc	a
		mov	A2,c
		rrc	a
		jc	IWSetCS1
		clr	CS0
		sjmp	IWSetCS0
IWSetCS1:
		clr	CS1
IWSetCS0:
		nop
		nop
		clr	WR
		nop
		nop
		setb	WR
		nop
		nop
		setb	CS1
		setb	CS0
		pop	acc
		ret
; ------------- cteni bajtu z IDE zarizeni, b=adresa, a=data -----------------
IDEReadByte:
		mov	CDLData,#255
		mov	CDHData,#255
		mov	a,b
		rrc	a
		mov	A0,c
		rrc	a
		mov	A1,c
		rrc	a
		mov	A2,c
		rrc	a
		jc	IRSetCS1
		clr	CS0
		sjmp	IRSetCS0
IRSetCS1:
		clr	CS1
IRSetCS0:
		nop
		nop
		clr	RD
		nop
		nop
		mov	a,CDLData
		mov	r2,CDHData
		setb	RD
		nop
		nop
		setb	CS1
		setb	CS0
		ret
; ------------- cekani na CD-ROM ---------------------------------------------
WaitForCDROM:
		push	acc
		push	b
		push	2
WaitForCDROMSm:
		push	7
		mov	r7,#0
WFCzpsm:
		nop
		nop
		djnz	r7,WFCzpsm
		pop	7
		mov	b,#7
		acall	IDEReadByte
		jb	acc.7,WaitForCDROMSm
		pop	2
		pop	b
		pop	acc
		ret
WaitForDRDY:
		push	acc
		push	b
		push	2
WaitForDRDYSm:
		mov	b,#7
		acall	IDEReadByte
		anl	a,#192
		cjne	a,#64,WaitForDRDYSm
		pop	2
		pop	b
		pop	acc
		ret
; ------------- reset IDE zarizeni -------------------------------------------
IDEReset:
		clr	IDEResetPin
		acall	zp2
		setb	IDEResetPin
		ret
; ------------- cekani na signal INTRQ nebo priznak DRQ z CD-ROM -------------
WaitForDRQINTRQ:
		push	acc
		push	b
WForDRQINTRQSm:
		clr	a
WFDIzpsm:
		nop
		dec	a
		jnz	WFDIzpsm
		jb	INTRQ,EndWForDRQINTRQ
		mov	b,#7
		acall	IDEReadByte
		jb	acc.3,EndWForDRQINTRQ
		jnb	acc.7,EndWForDRQINTRQ
		sjmp	WForDRQINTRQSm
EndWForDRQINTRQ:
		pop	b
		pop	acc
		ret
; ------------- cekani na priznak DRQ z CD-ROM -------------------------------
;WaitForDRQ:
;		push	acc
;		push	b
;		push	2
;WaitForDRQSm:
;		mov	b,#7
;		acall	IDEReadByte
;		jnb	acc.3,WaitForDRQSm
;		pop	2
;		pop	b
;		pop	acc
;		ret
; ------------- cekani na signal INTRQ z CD-ROM ------------------------------
WaitForINTRQ:
		push	acc
		clr	a
		mov	Timeout,a
		mov	Timeout+1,a
WForINTRQSm:
		setb	INTRQ
		mov	a,Timeout
		add	a,#1
		mov	Timeout,a
		mov	a,Timeout+1
		addc	a,#0
		mov	Timeout+1,a
		jc	WFITimedOut
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		jnb	INTRQ,EndWForINTRQ
EndWForINTRQ:
		pop	acc
		ret

WFITimedOut:

;		mov	a,#33
;		acall	zobrdisp
;		mov	b,#7
;		acall	IDEReadByte
;		acall	zobrhex
;		mov	b,#2
;		acall	IDEReadByte
;		acall	zobrhex

		pop	acc
		ret
; ------------- cekani na dalsi data podle nastaveni DRQ_INTRQMode -----------
WaitForDataValid:
		jb	DRQ_INTRQMode,WaitForINTRQ
;		ajmp	WaitForCDROM
		ret
; ------------- prevzeti dat z CD-ROM do CDROMDataWords ----------------------
GetCDROMDataWords:
		push	0
		push	7
		mov	r0,#CDROMDataWords
		mov	r7,#EndCDROMDataWords-CDROMDataWords
		clr	a
ZeroCDWSm:
		mov	@r0,a
		inc	r0
		djnz	r7,ZeroCDWSm
		mov	AtapiError,a
		mov	r0,#CDROMDataWords
GCDWSm:
		acall	zp3		; pockat min. 10 ms na assert DRQ/INTRQ
		acall	WaitForDataValid
		clr	a
		mov	Timeout,a
		mov	Timeout+1,a
GCDWBusy:
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		mov	a,Timeout
		add	a,#1
		mov	Timeout,a
		mov	a,Timeout+1
		addc	a,#0
		mov	Timeout+1,a
		jc	GCDWBTimedOut

		mov	b,#7
		acall	IDEReadByte
		jb	acc.7,GCDWBusy
		jnb	acc.3,DataReaded
		mov	b,#4
		acall	IDEReadByte
		mov	r5,a
		mov	b,#5
		acall	IDEReadByte
		clr	c
		rrc	a
		xch	a,r5
		rrc	a
		xch	a,r5
		mov	r6,a
RPDataSm:
		mov	b,#0
		acall	IDEReadByte
		mov	r7,a
		mov	a,r0
		clr	c
		subb	a,#EndCDROMDataWords
		jz	NeukladejPacketData
		mov	a,r7
		mov	@r0,a
		inc	r0
		mov	a,r2
		mov	@r0,a
		inc	r0
NeukladejPacketData:
		mov	a,r5
		clr	c
		subb	a,#1
		mov	r5,a
		mov	a,r6
		subb	a,#0
		mov	r6,a
		jnz	RPDataSm
		sjmp	GCDWSm
DataReaded:
		jnb	acc.1,NoPacketError
GCDWBTimedOut:
		mov	b,#1
		acall	IDEReadByte
		mov	AtapiError,a
NoPacketError:
		pop	7
		pop	0
		ret
; ------------- zvoleni IDE zarizeni a=0 ... master, 1 ... slave -------------
IDESelectDevice:
		anl	a,#1
		swap	a
		orl	a,#h'a0
		mov	b,#6
		mov	r2,#0
		acall	IDEWriteByte
		ret
; ------------- inicializace a detekce IDE CD-ROM ----------------------------
IDEInitDevice:
		setb	DRQ_INTRQMode
		clr	a
		acall	IDESelectDevice
		acall	WaitForCDROM
		acall	zp2
		mov	a,#h'c
		mov	r2,#0
		mov	b,#h'e
		acall	IDEWriteByte
		mov	a,#h'8
		mov	r2,#0
		mov	b,#h'e
		acall	IDEWriteByte
		acall	WaitForCDROM
		mov	b,#7
		mov	a,#8
		mov	r2,#0
		acall	IDEWriteByte
		acall	WaitForCDROM
		mov	b,#1
		clr	a
		mov	r2,#0
		acall	IDEWriteByte
		acall	CheckCDROMReady
		acall	IDEIdentifyDevice
		mov	a,#16
		acall	SetDPos
		mov	a,CDROMDataWords+1
		mov	c,acc.5
		mov	DRQ_INTRQMode,c
		jc	INTRQSupported
		mov	a,#10
		mov	b,#14
		mov	r2,#0
		acall	IDEWriteByte
INTRQSupported:
		ret
; ------------- otestovani, zda je mechanika pripravena ----------------------
CheckCDROMReady:
		push	acc
		push	b
		push	dpl
		push	dph
ChCRSm:
		mov	dptr,#PCheckReady
		acall	dptrSendPacketCommand
		acall	GetCDROMDataWords
		lcall	RequestSense
		mov	a,SenseKey
		jz	ChCRNoMedium
		cjne	a,#2,ChCRSm
		mov	a,ASC
		cjne	a,#h'3a,ChCRSm
ChCRNoMedium:
		pop	dph
		pop	dpl
		pop	b
		pop	acc
		ret
; ------------- vyslani paketoveho prikazu do IDE zarizeni z @dptr+ ----------
dptrSendPacketCommand:
		acall	WaitForCDROM
		clr	a
		acall	IDESelectDevice
		acall	WaitForCDROM
		clr	a
		mov	b,#1
		mov	r2,#0
		acall	IDEWriteByte
		clr	a
		mov	b,#5
		acall	IDEWriteByte
		mov	a,#2
		mov	b,#4
		acall	IDEWriteByte
		mov	a,#h'a0
		mov	b,#7
		acall	IDEWriteByte
		push	7
		mov	r7,#5
dSPCSm:
		acall	WaitForDRQINTRQ
		clr	a
		movc	a,@a+dptr
		inc	dptr
		mov	r2,a
		clr	a
		movc	a,@a+dptr
		mov	b,#0
		acall	IDEWriteByte
		inc	dptr
		djnz	r7,dSPCSm
		acall	WaitForDRQINTRQ
		mov	a,#0
		mov	b,#4
		mov	r2,#0
		acall	IDEWriteByte
		clr	a
		movc	a,@a+dptr
		inc	dptr
		mov	r2,a
		clr	a
		movc	a,@a+dptr
		mov	b,#0
		acall	IDEWriteByte
		pop	7
		ret
; ------------- vyslani paketoveho prikazu do IDE zarizeni z @r0+ ------------
r0SendPacketCommand:
		acall	WaitForCDROM
		clr	a
		acall	IDESelectDevice
		acall	WaitForCDROM
		clr	a
		mov	b,#1
		mov	r2,#0
		acall	IDEWriteByte
		mov	b,#5
		acall	IDEWriteByte
		mov	a,#2
		mov	b,#4
		acall	IDEWriteByte
		mov	a,#h'a0
		mov	b,#7
		acall	IDEWriteByte
		push	7
		mov	r7,#5
rSPCSm:
		acall	WaitForDRQINTRQ
		mov	a,@r0
		inc	r0
		mov	r2,a
		mov	a,@r0
		mov	b,#0
		acall	IDEWriteByte
		inc	r0
		djnz	r7,rSPCSm
		acall	WaitForDRQINTRQ
		mov	a,#0
		mov	b,#4
		mov	r2,#0
		acall	IDEWriteByte
		clr	a
		movc	a,@a+dptr
		inc	dptr
		mov	r2,a
		clr	a
		movc	a,@a+dptr
		mov	b,#0
		acall	IDEWriteByte
		pop	7
		ret
; ------------- identifikace IDE zarizeni ------------------------------------
IDEIdentifyDevice:
		acall	WaitForCDROM
		clr	a
		acall	IDESelectDevice
		acall	WaitForDRDY
		mov	a,#2
		mov	r2,#0
		mov	b,#1
		acall	IDEWriteByte
		mov	b,#5
		acall	IDEWriteByte
		mov	b,#4
		acall	IDEWriteByte
		mov	a,#h'a1
		mov	b,#7
		acall	IDEWriteByte
		acall	WaitForDRDY
		mov	r0,#CDROMDataWords
		mov	r5,#0
		mov	r6,#0
		acall	SmazDisplej
IDEReadIDSm:
		mov	b,#7
		acall	IDEReadByte
		jb	acc.7,IDEReadIDSm
		mov	b,#0
		acall	IDEReadByte
		mov	r7,a
		inc	r5
		mov	a,r5
		clr	c
		subb	a,#28
		jc	SkipZobr
		subb	a,#8
		jnc	SkipZobr
		mov	a,r2
		acall	zobrdisp
		mov	a,r7
		acall	zobrdisp
SkipZobr:
		mov	a,r0
		clr	c
		subb	a,#EndCDROMDataWords
		jz	NeukladejIDData
		mov	a,r2
		mov	@r0,a
		inc	r0
		mov	a,r7
		mov	@r0,a
		inc	r0
NeukladejIDData:
		djnz	r6,IDEReadIDSm
		ret
; ------------- otevreni dvirek mechaniky ------------------------------------
OpenDoor:
		push	acc
		push	b
		mov	dptr,#POpenDoor
		acall	dptrSendPacketCommand
		acall	GetCDROMDataWords
		pop	b
		pop	acc
		ret
; ------------- zavreni dvirek mechaniky -------------------------------------
CloseDoor:
		push	acc
		push	b
		mov	dptr,#PCloseDoor
		acall	dptrSendPacketCommand
		acall	GetCDROMDataWords
;		acall	CheckCDROMReady
;		mov	dptr,#PStartDisc
;		acall	dptrSendPacketCommand
;		acall	GetCDROMDataWords
		pop	b
		pop	acc
		ret
; ------------- zamceni dvirek mechaniky -------------------------------------
LockDoor:
		push	acc
		push	b
		mov	dptr,#PLockDoor
		acall	dptrSendPacketCommand
		acall	GetCDROMDataWords
		pop	b
		pop	acc
		ret
; ------------- odemceni dvirek mechaniky ------------------------------------
UnlockDoor:
		push	acc
		push	b
		mov	dptr,#PUnlockDoor
		acall	dptrSendPacketCommand
		acall	GetCDROMDataWords
		pop	b
		pop	acc
		ret
; ------------- pozastaveni prehravani audia ---------------------------------
PauseAudio:
		push	acc
		push	b
		mov	dptr,#PPauseAudio
		acall	dptrSendPacketCommand
		acall	GetCDROMDataWords
		pop	b
		pop	acc
		ret
; ------------- obnoveni prehravani audia ------------------------------------
ResumeAudio:
		push	acc
		push	b
		mov	dptr,#PResumeAudio
		acall	dptrSendPacketCommand
		acall	GetCDROMDataWords
		pop	b
		pop	acc
		ret
; ------------- zastaveni prehravani audia -----------------------------------
StopAudio:
		push	acc
		push	b
		mov	dptr,#PStopPlay
		acall	dptrSendPacketCommand
		acall	GetCDROMDataWords
		pop	b
		pop	acc
		ret
; ------------- spusteni prehravani audio od Pozice1 do Pozice2 v MSF --------
PlayAudioMSF:
		push	acc
		push	b
		acall	CheckCDROMReady
		acall	StopAudio
		acall	CheckCDROMReady
		mov	a,Pozice1
		mov	PacketCommand+4,a
		mov	a,Pozice1+1
		mov	PacketCommand+5,a
		mov	a,Pozice1+2

; debug
;		add	a,#3

		mov	PacketCommand+2,a
		clr	a
		mov	PacketCommand+3,a
		mov	PacketCommand,a
		mov	PacketCommand+8,a
		mov	PacketCommand+10,a
		mov	PacketCommand+11,a
		mov	a,#h'47
		mov	PacketCommand+1,a
		mov	a,CDSize
		mov	PacketCommand+9,a
		mov	a,CDSize+1
		mov	PacketCommand+6,a
		mov	a,CDSize+2
		mov	PacketCommand+7,a
		mov	r0,#PacketCommand
		acall	r0SendPacketCommand
		acall	GetCDROMDataWords
		pop	b
		pop	acc
		ret
; ------------- zjisteni velikosti CD v sektorech ----------------------------
GetCDSize:
		push	acc
		push	b
		mov	dptr,#PCDSize
		acall	dptrSendPacketCommand
		acall	GetCDROMDataWords
		clr	a
		mov	CDSize,a
		mov	CDSize+1,a
		mov	CDSize+2,a
		mov	CDSize+3,a
		mov	a,AtapiError
		jnz	NoCD
		mov	CDSize,CDROMDataWords+3
		mov	CDSize+1,CDROMDataWords+2
		mov	CDSize+2,CDROMDataWords+1
		mov	CDSize+3,CDROMDataWords
		mov	a,CDSize
		clr	c
		subb	a,#1
		mov	CDSize,a
		mov	CDSizeHSG,a
		mov	a,CDSize+1
		subb	a,#0
		mov	CDSize+1,a
		mov	CDSizeHSG+1,a
		mov	a,CDSize+2
		subb	a,#0
		mov	CDSize+2,a
		mov	CDSizeHSG+2,a
		mov	a,CDSize+3
		subb	a,#0
		mov	CDSize+3,a
		mov	CDSizeHSG+3,a
		mov	r0,#CDSize
		lcall	Sector2MSF2
NoCD:
		lcall	RequestSense
		mov	a,SenseKey
		cjne	a,#2,OkCDSize
		mov	a,ASC
		cjne	a,#h'3a,OkCDSize
		clr	a
		mov	CDSize,a
		mov	CDSize+1,a
		mov	CDSize+2,a
		mov	CDSize+3,a
OkCDSize:
		pop	b
		pop	acc
		ret
; ------------- zjisteni vysledku provedeneho prikazu ------------------------
RequestSense:
		push	acc
		push	b
		mov	dptr,#PRequestSense
		lcall	dptrSendPacketCommand
		lcall	GetCDROMDataWords

		mov	a,CDROMDataWords+2
		mov	SenseKey,a
		mov	a,CDROMDataWords+12
		mov	ASC,a
		mov	a,CDROMDataWords+13
		mov	ASCQ,a

;		mov	a,#16
;		lcall	SetDPos
;		mov	a,#82
;		lcall	zobrdisp
;		mov	a,#83
;		lcall	zobrdisp
;		mov	a,CDROMDataWords+2
;		lcall	zobrhex
;		mov	a,CDROMDataWords+12
;		lcall	zobrhex
;		mov	a,CDROMDataWords+13
;		lcall	zobrhex

		pop	b
		pop	acc
		ret
; ------------- spusteni prehravani od tracku acc ----------------------------
PlayFromTrack:
		push	acc
		push	b
		lcall	SmazDisplej
		mov	dptr,#SeekText
		lcall	Print
		lcall	CheckCDROMReady
		lcall	StopAudio
		lcall	CheckCDROMReady
		mov	a,TrackNr
		jnz	OkPFTTrackNr
		inc	a
OkPFTTrackNr:
		lcall	TrackSector
		jnz	PFTNoAudio
		lcall	CheckCDROMReady
;		lcall	Seek
;		lcall	CheckCDROMReady
		mov	r0,#Pozice1
		lcall	Sector2MSF
		lcall	GetCDSize
		mov	Pozice2,CDSize
		mov	Pozice2+1,CDSize+1
		mov	Pozice2+2,CDSize+2
		mov	Pozice2+3,CDSize+3
		lcall	PlayAudioMSF
		mov	TrackP,TrackNr
PFTNoAudio:
		pop	b
		pop	acc
		ret
; ------------- presun pozice na zadany sektor Pozice1 -----------------------
Seek:
		mov	a,Pozice1
		mov	PacketCommand+4,a
		mov	a,Pozice1+1
		mov	PacketCommand+5,a
		mov	a,Pozice1+2
		mov	PacketCommand+2,a
		mov	a,Pozice1+3
		mov	PacketCommand+3,a
		mov	a,#h'2b
		mov	PacketCommand+1,a
		clr	a
		mov	PacketCommand,a
		mov	PacketCommand+6,a
		mov	PacketCommand+7,a
		mov	PacketCommand+8,a
		mov	PacketCommand+9,a
		mov	PacketCommand+10,a
		mov	PacketCommand+11,a
		mov	r0,#PacketCommand
		lcall	r0SendPacketCommand
		lcall	GetCDROMDataWords
		ret
; ------------- zjisti informace o tracku a ----------------------------------
; ------------- a=0 audio, 1 data, 255 neexistuje, b= pocet tracku na CD -----
; ------------- pokud track existuje, 1. sektor do Pozice1 -------------------
TrackSector:
		mov	PacketCommand+1,#h'43
		mov	PacketCommand+7,a
		clr	a
		mov	PacketCommand,a
		mov	PacketCommand+2,a
		mov	PacketCommand+3,a
		mov	PacketCommand+4,a
		mov	PacketCommand+5,a
		mov	PacketCommand+6,a
		mov	PacketCommand+8,a
		mov	PacketCommand+9,#h'c
		mov	PacketCommand+10,a
		mov	PacketCommand+11,a
		mov	r0,#PacketCommand
		lcall	r0SendPacketCommand
		lcall	GetCDROMDataWords
		mov	a,AtapiError
		jnz	TrackNotExist

;		acall	smazdisplej
;		mov	a,CDROMDataWords+1
;		acall	zobrhex
;		mov	a,CDROMDataWords+2
;		acall	zobrhex
;		mov	a,CDROMDataWords+3
;		acall	zobrhex
;		mov	a,CDROMDataWords+6
;		acall	zobrhex
;		mov	a,CDROMDataWords+8
;		acall	zobrhex
;		mov	a,CDROMDataWords+9
;		acall	zobrhex
;		mov	a,CDROMDataWords+10
;		acall	zobrhex
;		mov	a,CDROMDataWords+11
;		acall	zobrhex
;		acall	RequestSense
;		acall	CheckCDROMReady

		mov	NrOfTracks,CDROMDataWords+3
		mov	Pozice1+3,CDROMDataWords+8
		mov	Pozice1+2,CDROMDataWords+9
		mov	Pozice1+1,CDROMDataWords+10
		mov	Pozice1,CDROMDataWords+11
		lcall	RequestSense
		mov	a,SenseKey
		jnz	TrackNotExist
		clr	a
		ret
TrackNotExist:
		mov	NrOfTracks,#0
		mov	a,#255
		ret
; ------------- zjisteni aktualni pozice pri prehravani ----------------------
; ------------- Pozice1 - MSF pozice na CD -----------------------------------
; ------------- Pozice2 - MSF pozice v tracku --------------------------------
; ------------- TrackP - track, IndexP - index, acc - Audio Status -----------
PlayingPosition:
		mov	dptr,#PRequestPositionMSF
		lcall	dptrSendPacketCommand
		lcall	GetCDROMDataWords
		mov	a,AtapiError
		jnz	ErrPlayingPosition
		mov	a,CDROMDataWords+6
		mov	TrackP,a
		mov	a,CDROMDataWords+7
		mov	IndexP,a
		mov	a,CDROMDataWords+8
		mov	Pozice1+3,a
		mov	a,CDROMDataWords+9
		mov	Pozice1+2,a
		mov	a,CDROMDataWords+10
		mov	Pozice1+1,a
		mov	a,CDROMDataWords+11
		mov	Pozice1,a
		mov	a,CDROMDataWords+12
		mov	Pozice2+3,a
		mov	a,CDROMDataWords+13
		mov	Pozice2+2,a
		mov	a,CDROMDataWords+14
		mov	Pozice2+1,a
		mov	a,CDROMDataWords+15
		mov	Pozice2,a
		mov	a,Pozice1
		clr	c
		subb	a,#2
		mov	Pozice1,a
		jnc	OkGPP
		push	psw
		add	a,#60
		mov	Pozice1,a
		pop	psw
		mov	a,Pozice1+1
		subb	a,#0
		mov	Pozice1+1,a
		jnc	OkGPP
		push	psw
		add	a,#60
		mov	Pozice1+1,a
		pop	psw
		mov	a,Pozice1+2
		subb	a,#0
		mov	Pozice1+2,a
OkGPP:
		mov	a,CDROMDataWords+1
		ret
ErrPlayingPosition:
		clr	a
		ret
; ------------- prevod 4B ze sektoru na MSF z @r0+ ---------------------------
Sector2MSF:
; +150
		mov	a,@r0
		add	a,#150
		mov	@r0,a
		inc	r0
		mov	a,@r0
		addc	a,#0
		mov	@r0,a
		inc	r0
		mov	a,@r0
		addc	a,#0
		mov	@r0,a
		inc	r0
		mov	a,@r0
		addc	a,#0
		mov	@r0,a
		dec	r0
		dec	r0
		dec	r0
Sector2MSF2:
		mov	r2,#-1		; M
Sub4500:
		push	0
		mov	a,@r0
		clr	c
		subb	a,#h'94
		mov	@r0,a
		inc	r0
		mov	a,@r0
		subb	a,#h'11
		mov	@r0,a
		inc	r0
		mov	a,@r0
		subb	a,#0
		mov	@r0,a
		inc	r0
		mov	a,@r0
		subb	a,#0
		mov	@r0,a
		pop	0
		inc	r2
		jnc	Sub4500
; korekce4500
		mov	a,@r0
		add	a,#h'94
		mov	@r0,a
		inc	r0
		mov	a,@r0
		addc	a,#h'11
		mov	@r0,a
		dec	r0
		mov	r3,#-1		; S
Sub75:
		mov	a,@r0
		clr	c
		subb	a,#75
		mov	@r0,a
		inc	r0
		mov	a,@r0
		subb	a,#0
		mov	@r0,a
		dec	r0
		inc	r3
		jnc	Sub75
		mov	a,@r0
		add	a,#75
		mov	@r0,a		; F
		inc	r0
		mov	a,r3
		mov	@r0,a
		inc	r0
		mov	a,r2
		mov	@r0,a
		ret
; ------------- paketove prikazy pro CD-ROM ----------------------------------
PCheckReady:
		.dw	0,0,0,0,0,0
;PStartDisc:
;		.dw	0x1b,0,1,0,0,0
POpenDoor:
		.dw	h'1b,0,2,0,0,0
PCloseDoor:
		.dw	h'1b,0,3,0,0,0
PLockDoor:
		.dw	h'1e,0,1,0,0,0
PUnlockDoor:
		.dw	h'1e,0,0,0,0,0
PPauseAudio:
		.dw	h'4b,0,0,0,0,0
PResumeAudio:
		.dw	h'4b,0,0,0,1,0
PStopPlay:
		.dw	h'4e,0,0,0,0,0
PCDSize:
		.dw	h'25,0,0,0,0,0
PRequestSense:
		.dw	3,0,18,0,0,0
PRequestPositionMSF:
		.dw	h'0242,h'0140,0,0,32,0
; ------------- zjisteni delky tracku ----------------------------------------
GetTrackSize:
		mov	a,TrackNr
		cjne	a,NrOfTracks,GetNextTrackSector
		mov	TrackSize,CDSizeHSG
		mov	TrackSize+1,CDSizeHSG+1
		mov	TrackSize+2,CDSizeHSG+2
		mov	TrackSize+3,CDSizeHSG+3
		sjmp	GetTrackSector
GetNextTrackSector:
		inc	a
		lcall	TrackSector
		mov	TrackSize,Pozice1
		mov	TrackSize+1,Pozice1+1
		mov	TrackSize+2,Pozice1+2
		mov	TrackSize+3,Pozice1+3
GetTrackSector:
		mov	a,TrackNr
		lcall	TrackSector
		mov	a,TrackSize
		clr	c
		subb	a,Pozice1
		mov	TrackSize,a
		mov	a,TrackSize+1
		subb	a,Pozice1+1
		mov	TrackSize+1,a
		mov	a,TrackSize+2
		subb	a,Pozice1+2
		mov	TrackSize+2,a
		mov	a,TrackSize+3
		subb	a,Pozice1+3
		mov	TrackSize+3,a
		mov	r0,#TrackSize
		acall	Sector2MSF2
		ret
; ------------- texty --------------------------------------------------------
UvLogo:
		.db	16,"Papouch&DMC 2000"
UvLogo2:
		.db	16,"Detecting CDROM "
NoRepeatText:
		.db	10,"          "
Repeat1Text:
		.db	10,"REPEAT 1  "
RepeatAllText:
		.db	10,"REPEAT A  "
NoRandomText:
		.db	6,"      "
RandomText:
		.db	6,"RANDOM"
OpeningText:
		.db	13,"   Opening..."
ClosingText:
		.db	13,"   Closing..."
SeekText:
		.db	10,"      SEEK"
		.end

		acall	smazdisplej
		mov	r7,#8
		mov	r0,#CDROMDataWords
zsm:
		mov	a,@r0
		acall	zobrhex
		inc	r0
		djnz	r7,zsm

